@echo off
rem /* IBM Confidential
rem  *
rem  * OCO Source Materials
rem  *
rem  * 5724-E11
rem  * 5724-E26
rem  * (C) Copyright IBM Corp. 2002
rem  *
rem  * The source code for this program is not published or otherwise
rem  * divested of its trade secrets, irrespective of what has been deposited
rem  * with the U.S. Copyright office
rem  */

if %4 NEQ -10 goto NOTDSPMQ
  
  rem ### dspmq ###
  dspmq
  exit

:NOTDSPMQ

if %4 NEQ -2 goto NOTMQSILIST

  rem ### List MQSI components ###
  call %3
  rem @echo on
  mqsilist %5
  exit

:NOTMQSILIST
  
if %4 NEQ -1 goto NOTDB2PATH

  rem ### return DB2PATH environment settings ###

  rem @echo on
  db2set db2path
  exit

:NOTDB2PATH

if %4 NEQ 1 goto NOTLISTDB2

  rem ### list db2 databases ###
  cd %~2  
  db2cmd /c /w /i listDB2Databases.bat
  exit

:NOTLISTDB2

if %4 NEQ 2 goto NOTCREATEDB2DB

  rem ### create a db2 database ###
  cd %~2  
  db2cmd /c /w /i createDB2Database.bat %5
  exit

:NOTCREATEDB2DB

if %4 NEQ 3 goto NOTCREATEGENERICDB

  rem ### create a generic database using mqsicreatedb ###
  call %3
  @echo on
  CALL mqsicreatedb %5 -i %6 -a %7
  exit

:NOTCREATEGENERICDB

if %4 NEQ 4 goto NOTBINDDB2DB

  rem ### bind to a db2 database ###
  cd %~2  
  db2cmd /c /w /i bindtoDB2Database.bat %5 %~s1
  exit

:NOTBINDDB2DB

if %4 NEQ 5 goto NOTGRANTDB2DB

  rem ### grant authorities on a db2 database ###
  cd %~2  
  db2cmd /c /w /i grantOnDB2Database.bat %5 %6
  exit

:NOTGRANTDB2DB

if %4 NEQ 6 goto NOTODBC

  rem ### create a ODBC data source for a db2 database ###
  cd %~2  
  db2cmd /c /w /i createDB2Datasource.bat %5
  exit

:NOTODBC

if %4 NEQ 7 goto NOTDROPDB2DB

  rem ### drop a DB" database and delete it's ODBC connection ###
  cd %~2  
  db2cmd /c /w /i dropDB2Database.bat %5
  exit

:NOTDROPDB2DB

if %4 NEQ 8 goto NOTDROPGENERICDB

  rem ### drop a generic DB ###
  call %3
  @echo on
  mqsideletedb %5
  exit

:NOTDROPGENERICDB

rem ### broker tasks ###

if %4 NEQ 9 goto NOTMQSICONFGCMD

  rem ### A Generic command, expected to be an mqsi... command ###

  call %3
  @echo on
  %~5 
  exit

:NOTMQSICONFGCMD

if %4 NEQ 10 goto NOTPOPULATEDB

  rem ### PlaceHolder ###
  
  exit

:NOTPOPULATEDB

if %4 NEQ 11 goto NOTMQSIBRKRCMD

  rem ### create a broker  ###

  call %3
  @echo on
  %~5
  exit

:NOTMQSIBRKRCMD

if %4 NEQ 12 goto NOTMQSISTRTCFGCMD

  rem ### start configuration manager  ###
  call %3
  @echo on
  mqsistart ConfigMgr
  exit

:NOTMQSISTRTCFGCMD

if %4 NEQ 13 goto NOTMQSISTRTBROKERCMD

  rem ### start broker  ###
  call %3
  @echo on
  mqsistart %5
  exit

:NOTMQSISTRTBROKERCMD

if %4 NEQ 14 goto NOTMQCREATEQUEUE

  rem ### Create an MQ queue ###
  echo DEFINE %5(%6) REPLACE | runmqsc %7
  exit

:NOTMQCREATEQUEUE

if %4 NEQ 15 goto NOTMQDELETEQUEUE

  rem ### Delete an MQ queue ###
  echo DELETE %5(%6) PURGE | runmqsc %7
  exit

:NOTMQDELETEQUEUE

if %4 NEQ 45 goto NOTMQDELETEMODELQUEUE

  rem ### Delete an MQ model queue ###
  echo DELETE %5(%6) | runmqsc %7
  exit

:NOTMQDELETEMODELQUEUE
  
if %4 NEQ 18 goto NOTMQCREATECHANNEL

  rem ### Create an MQ channel ###
  echo DEFINE CHANNEL(%5) CHLTYPE(%6) REPLACE | runmqsc %7
  exit 

:NOTMQCREATECHANNEL

if %4 NEQ 19 goto NOTMQDELETECHANNEL

  rem ### Delete an MQ channel ###
  echo DELETE CHANNEL(%5) | runmqsc %6
  exit

:NOTMQDELETECHANNEL

if %4 NEQ 41 goto NOTADDLISTENER_V6
  
  rem ### Add listener to QueueManager ###
  
  echo DEFINE LISTENER(%5) TRPTYPE(TCP) PORT(%6) CONTROL(QMGR) | runmqsc %5
  echo START LISTENER(%5) | runmqsc %5

  exit

:NOTADDLISTENER_V6

if %4 NEQ 46 goto NOTADDLISTENER_V5
  
  rem ### Add listener to QueueManager ###
  rem ### Use amqmdain instead of runmqlsr directly because we want control returned to us.
  amqmdain crtlsr %5 -t TCP -p %6
  
  rem ### start all services associated with the qmgr, inc. listener ###
  amqmdain start %5
  
  rem ### check there's now something listening on the right port ###
  rem ### this is a very crude check - it would be better to connect a client ###
  rem ### but it doesn't matter too much as we'll just catch an error later in the wizard
  netstat -a -p TCP
  rem ### above output should include a line with :[port] ... LISTENING
  rem ### ... but we can't rely on the LISTENING as it can vary with locale

  exit

:NOTADDLISTENER_V5

if %4 NEQ 42 goto NOTSTARTQM
  
  rem ### Start QueueManager ###
  
  strmqm %5
  if %errorlevel% EQU 0 echo WMQI_WIZ_COMMAND_SUCCESS 
  if %errorlevel% EQU 5 echo WMQI_WIZ_COMMAND_SUCCESS
  exit

:NOTSTARTQM

if %4 NEQ 47 goto NOTAUTOSTARTUPQM
  
  rem ### Start Default QueueManager Automatically ###
  
  amqmdain auto %5
  exit

:NOTAUTOSTARTUPQM
